; ukazkovy program ucebnice programovani PIC
; verze 1.2
; lze pouze prelozit, obsahuje direktivy prekladace, ale nic nedela
; obsahuje definice hardware jednotky
; inicializace procesoru a zakladni osetreni preruseni

 LIST P=16F84, R=DEC                    ; direktivy prekladace

 include<p16f84.inc>                    ; definice nazvu registru

                                        ; definice zapojeni hardware
KL_R1     EQU     3                     ; portb
KL_R2     EQU     2                     ; portb
KL_R3     EQU     1                     ; portb
KL_S1     EQU     4                     ; portb
KL_S2     EQU     5                     ; portb
KL_S3     EQU     6                     ; portb
KL_S4     EQU     7                     ; portb
IN_RND    EQU     0                     ; portb
AD_OUT    EQU     4                     ; porta
OUT_STR   EQU     3                     ; porta
OUT_D     EQU     2                     ; portb
OUT_CLK   EQU     3                     ; portb
OUTPIP    EQU     2                     ; porta
AN1       EQU     1                     ; porta
AN2       EQU     0                     ; porta

;--------------------------------------------------------------------
; promenne
;--------------------------------------------------------------------

OffRam    EQU     0x0C                  ; offset pameti pro PIC16F84
Mem_W     EQU     OffRam                ; pamet pracovniho registru
Mem_Stat  EQU     OffRam+1              ; pamet registru STATUS

;--------------------------------------------------------------------
; kod programu
;--------------------------------------------------------------------

                ORG     0       
                GOTO    Start           ; skok na zacatek programu

                ORG     4               ;
                GOTO    IntProc         ; skok na obsluhu preruseni

;--------------------------------------------------------------------
; hlavni program
;--------------------------------------------------------------------

Start                                   ; inicializace procesoru
                BSF     STATUS,RP0      ; registrova sada 1
                MOVLW   0xC5            ; nastaveni OPTION
                MOVWF   OPTION_REG      ; ok
                CLRF    TRISA           ; piny PORTA jako vystupy
                MOVLW   0xF1            ; RB0 a RB4 az RB7 vstupy
                MOVWF   TRISB           ; jinak vystupy
                BCF     STATUS,RP0      ; registriva sada 0
                CLRF    PORTA           ; cely PORTA do 0
                MOVLW   0xFF            ; cely PORTB do 1
                MOVWF   PORTB           ; ok
                MOVLW   0xB0            ; povoleni preruseni
                MOVWF   INTCON          ; ok
Main            

                GOTO    Main            ;

;--------------------------------------------------------------------
; obsluzne procedury
;--------------------------------------------------------------------

IntProc                                 ; obsluha preruseni
                MOVWF   Mem_W           ; ulozeni registru W
                MOVF    STATUS,W        ; ulozeni obsahu STATUS
                MOVWF   Mem_Stat        ; ok
                BCF     INTCON,T0IF     ; clr priznaku preruseni TMR0

                MOVF    Mem_Stat,W      ; obnova stavu STATUS
                MOVWF   STATUS          ; ok
                SWAPF   Mem_W,F         ; obnova registru W
                SWAPF   Mem_W,W         ; ok
                RETFIE                  ; navrat z preruseni

                END                     ; konec programu

