/* program k programovani procesoru PIC16F84 */

#define Uses_TApplication
#define Uses_TFileDialog
#define Uses_TDeskTop
#define Uses_TRect
#define Uses_TWindow
#define Uses_TDialog
#define Uses_TScrollBar
#define Uses_TEditor
#define Uses_TKeys
#define Uses_TStaticText
#define Uses_TRadioButtons
#define Uses_TCheckBoxes
#define Uses_TSItem
#define Uses_TStatusLine
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TStatusDef
#define Uses_TStatusItem
#define Uses_MsgBox

#include <tv.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos.h>
#include <conio.h>

#define   cmReadPIC     100
#define	  cmWritePIC    101
#define	  cmVerifyPIC   102
#define	  cmErasePIC    103
#define	  cmAbout       104
#define	  cmOpenHex     105
#define	  cmNewFile     106

#define   COM1     0x3F8
#define   COM2     0x2F8
#define   COM3     0x3E8
#define   COM4     0x2E8

unsigned int ComX = NULL;                        // parametr portu

void MyDel() {                                   // male zpozdeni
  int i;
    for (i=0;i<500;i++)
	asm NOP;
}

#define   InitCom  outp(ComX+4,0x0C)
#define   SetData  outp(ComX+4,inp(ComX+4)|0x01)
#define   ClrData  outp(ComX+4,inp(ComX+4)&0xFE)
#define   SetClk   outp(ComX+4,inp(ComX+4)|0x02)
#define   ClrClk   outp(ComX+4,inp(ComX+4)&0xFD)
#define   SetMclr  outp(ComX+3,0x40)
#define   ClrMclr  outp(ComX+3,0)
#define   RdData   ((inp(ComX+6)&0x10)!=0) ? True : False
#define   TestCom  ((inp(ComX+4)&0xE0)==0) ? True : False
#define   ClkPulz  SetClk;MyDel();ClrClk;MyDel()
#define   ResChip  ClrClk;ClrData;ClrMclr;MyDel();SetMclr;MyDel()

void CMD(unsigned char Data) {                   // procedura zapise povel
  int i;
    for (i=0;i<6;i++) {
	if ((Data&0x01)==0)
	   ClrData;
	   else
		SetData;
	Data >>= 1;
	ClkPulz;
    }
}                                                // ok

unsigned int RdDATA() {                          // nacteni dat
  unsigned int Buf = 0;
  int i;
    SetData;                                      // prednastaveni H pro cteni
    ClkPulz;
    for (i=0;i<14;i++) {                          // nacteni dat
	ClkPulz;
	if (RdData==True)
	   Buf |= 0x4000;
	Buf >>= 1;
    }
    ClkPulz;
    return( Buf );
}                                                 // ok

void WrDATA(unsigned int Data) {                  // nacteni dat
  unsigned int Buf;
  int i;
    ClrData;                                      // startbit
    ClkPulz;
    for (i=0;i<14;i++) {                          // zapis dat
	if ((Data&0x0001)!=0)
	   SetData;
	   else
		ClrData;
	Data >>= 1;
	ClkPulz;
    }
    ClrData;                                      // stopbit
    ClkPulz;
}                                                 // ok

typedef enum {                                    // vyjmenovany typ statusu
    none,
    dread,
    dwrite,
    dverify,
    derase
} STAT;                                          // ok

STAT status = none;                              // definice promenne
unsigned int Rotator = 0;                        // pocatek rotatoru
unsigned int Delitel = 0;                        // delitel udalosti timeru

class TControlWnd : public TDialog {             // definice tridy okna rizeni

public :

    TStaticText *PortInfo;                       // zdetekovany port
    TControlWnd();                               // konstruktor ridiciho okna
    void ClearDat();                             // clr okna rizeni
    void WriteDat(int Data);                     // zapise data do pole
    unsigned int ReadDat();                      // precte data z pole
    void CurOvl(Boolean Stav);                   // ovladani kurzoru
    void WriteName( char *StrBuf, int Par );     // zapise nazev nacteneho souboru

protected :

    TStaticText *FileInfo;                       // nazev nacteneho souboru
    TRadioButtons *Speed;                        // prepinac oscilatoru
    TCheckBoxes *ModeProg;                       // parametry programovani
    virtual void handleEvent( TEvent& event );   // procedura udalosti
    virtual TPalette& getPalette() const;        // procedura barev

};

class TCodeWnd : public TWindow {                // definice tridy okna kodu

public :

    TCodeWnd();                                  // konstruktor kodoveho okna
    void ClearDat();                             // procedura vymaze data z pameti
    void WriteDat(int Adr, int Data);            // zapise data do pole
    unsigned int ReadDat(int Adr);               // precte data z pole
    void CurOvl(Boolean Stav);                   // ovladani kurzoru

protected:

    TEditor *CODE;                               // objekt editoru dat
    TScrollBar *MyBar;                           // objekt posuvu okna
    TStaticText *AdrWnd;                         // objekt aktualni adresy
    int DataAdr, Pos;                            // adresa aktualni bunky a pozice
    void MakeCurPos();                           // ovladani pozice kurzoru
    virtual void handleEvent( TEvent& event );   // procedura udalosti
    virtual TPalette& getPalette() const;        // procedura barev

};

class TEpromWnd : public TWindow {               // definice tridy okna kodu

public :

    TEpromWnd();                                 // konstruktor kodoveho okna
    void ClearDat();                             // procedura vymaze data z pameti
    void WriteDat(int Adr, int Data);            // zapise data do pole
    unsigned int ReadDat(int Adr);               // precte data z pole
    void CurOvl(Boolean Stav);                   // ovladani kurzoru

protected:

    TEditor *EPROM;                              // objekt editoru dat
    TStaticText *AdrWnd;                         // objekt aktualni adresy
    int DataAdr, Pos;                            // adresa aktualni bunky a pozice
    void MakeCurPos();                           // ovladani pozice kurzoru
    virtual void handleEvent( TEvent& event );   // procedura udalosti
    virtual TPalette& getPalette() const;        // procedura barev

};

class TIdentWnd : public TWindow {               // definice tridy okna kodu

public :

    TIdentWnd();                                 // konstruktor kodoveho okna
    void ClearDat();                             // procedura vymaze data z pameti
    void WriteDat(int Adr, int Data);            // zapise data do pole
    unsigned int ReadDat(int Adr);               // precte data z pole
    void CurOvl(Boolean Stav);                   // ovladani kurzoru

private:

    TEditor *Ident;                              // objekt editoru dat
    int DataAdr, Pos;                            // adresa aktualni bunky a pozice
    void MakeCurPos();                           // ovladani pozice kurzoru
    virtual void handleEvent( TEvent& event );   // procedura udalosti
    virtual TPalette& getPalette() const;        // procedura barev
};

class TPicProg : public TApplication {           // definice tridy hlavni aplikace

public :

    TPicProg();                                  // konstruktor hlavni aplikace

protected :

    TCodeWnd *CodeWnd;                           // okno kodu programu
    TEpromWnd *EpromWnd;                         // okno pameti eeprom
    TIdentWnd *IdentWnd;                         // okno identifikace
    TControlWnd *SetWnd;                         // okno rizeni
    virtual TPalette& getPalette() const;        // procedura barev
    static TStatusLine *initStatusLine(TRect r); // definice panelu povelu
    static TMenuBar *initMenuBar( TRect r );     // definice menu povelu
    virtual void handleEvent( TEvent& event );   // procedura udalosti
    void openFile();                             // procedura otevre soubor hex
    void Beep();                                 // procedura pipne
    void CurOvl(Boolean Stav);                   // ovladani kurzoru
    void FindPrgm();                             // procedura vyhleda hardware
    void ReadPIC();                              // procedura nacte PIC
    void WritePIC();                             // procedura naprogramuje PIC
    void VerifyPIC();                            // procedura zkontroluje data
    void ErasePIC();                             // procedura vymaze PIC
};

TPicProg *AppPtr;                                // ukazatel na celou aplikaci

/* ============================== TPicProg ================================ */

TPicProg::TPicProg() :                           // telo konstruktoru hlavni aplikace
    TProgInit(
	       &TPicProg::initStatusLine,
	       &TPicProg::initMenuBar,
	       &TPicProg::initDeskTop
	     )
{
    redraw();
    CodeWnd = new TCodeWnd();                    // okno kodu na plochu
    deskTop->insert( CodeWnd );                  // ok
    EpromWnd = new TEpromWnd();                  // okno eprom na plochu
    deskTop->insert( EpromWnd );                 // ok
    IdentWnd = new TIdentWnd();                  // okno ident na plochu
    deskTop->insert( IdentWnd );                 // ok
    SetWnd = new TControlWnd();                  // okno rizeno na plochu
    deskTop->insert( SetWnd );                   // ok
    FindPrgm();                                  // otestuje hardware
};

TStatusLine *TPicProg::initStatusLine(TRect r) {
  r.a.y = r.b.y - 1;
  return new TStatusLine(r,
     *new TStatusDef(0,0xFFFF) +
     *new TStatusItem("~Alt+X~ Exit",kbAltX,cmQuit) +
     *new TStatusItem("~Alt-R~ Read",kbAltR,cmReadPIC) +
     *new TStatusItem("~Alt-W~ Write",kbAltW,cmWritePIC) +
     *new TStatusItem("~Alt-V~ Verify",kbAltV,cmVerifyPIC) +
     *new TStatusItem("~Alt-E~ Erase",kbAltE,cmErasePIC)+
     *new TStatusItem( "~F10~ Menu", kbF10, cmMenu )
  );
}

TMenuBar *TPicProg::initMenuBar( TRect r ) {     // redefinice menu povelu
    r.b.y = r.a.y + 1;
    return new TMenuBar( r,
       *new TSubMenu("~-~", kbAltMinus ) +
       *new TMenuItem("~A~bout...",cmAbout,kbAltA,hcNoContext,NULL) +
       *new TSubMenu("~F~ile",kbAltF ) +
       *new TMenuItem("~N~ew",cmNewFile,kbAltN,hcNoContext,NULL) +
       *new TMenuItem("~O~pen",cmOpenHex,kbF3,hcNoContext,"F3") +
       newLine() +
       *new TMenuItem("~E~xit",cmQuit,kbAltX,hcNoContext,"Alt-X")
    );
}

void TPicProg::handleEvent(TEvent& event) {      // procedura udalosti okna kodu
    if ((event.what)==evCommand) {
	switch (event.message.command) {
	  case cmAbout :
	    messageBox(
	    "    Programmer PIC16F84 ver.1.0\n       Copyright (c) 1999 by\n         ING.Vaclav VACEK",
	    mfOKButton+mfInformation);
	  break;
	  case cmNewFile :
	    CodeWnd->ClearDat();
	    EpromWnd->ClearDat();
	    IdentWnd->ClearDat();
	    SetWnd->ClearDat();
	  break;
	  case cmOpenHex :
	    openFile();                          // otevre soubor HEX
	  break;
	  case cmErasePIC:                       // vymaze obvod PIC
	    FindPrgm();
	    if (ComX==NULL)
	       break;
	    CurOvl( False );
	    status = derase;
	    Beep();
	    if (messageBox("Do you wisch erase PIC?",mfConfirmation+mfYesButton+mfNoButton)==cmYes)
	       ErasePIC();
	    status = none;
	    CurOvl( True );
	    AppPtr->redraw();
	  break;
	  case cmVerifyPIC:                      // porovna obvod PIC
	    FindPrgm();
	    if (ComX==NULL)
	       break;
	    CurOvl( False );
	    VerifyPIC();
	    status = none;
	    CurOvl( True );
	    AppPtr->redraw();
	  break;
	  case cmWritePIC:                      // naprogramuje obvod PIC
	    FindPrgm();
	    if (ComX==NULL)
	       break;
	    CurOvl( False );
	    WritePIC();
	    status = none;
	    CurOvl( True );
	    AppPtr->redraw();
	  break;
	  case cmReadPIC:                       // nacte obvod PIC
	    FindPrgm();
	    if (ComX==NULL)
	       break;
	    CurOvl( False );
	    ReadPIC();
	    status = none;
	    CurOvl( True );
	    AppPtr->redraw();
	  break;
	  default:
	  break;
	}
    }
    if ((event.what)==evKeyboard) {              // klavesove udalosti
	switch ( event.keyDown.keyCode ) {       // obsluha funkcnich klaves
	 case kbTab :
	   if (deskTop->current==IdentWnd) {
	      SetWnd->select();
	      break;
	   }
	   if (deskTop->current==EpromWnd) {
	      IdentWnd->select();
	      break;
	   }
	   if (deskTop->current==CodeWnd) {
	      EpromWnd->select();
	      break;
	   }
	   if (deskTop->current==SetWnd) {
	      CodeWnd->select();
	      break;
	   }
	 break;
	 default :
	 break;
       }
    }                                            // udalosti predchudce
    TApplication::handleEvent( event );
}

void TPicProg::openFile()
{
  char fileName[MAXPATH] = "";
  FILE *fr = NULL;
  char StrBuf[255], Buf[3] = "00", AdrBuf[5] = "0000", DataBuf[5] = "0000";
  unsigned int i, Length, CRC, Data, OffAdr, Direct;
    TFileDialog *d= (TFileDialog *)validView(
	new TFileDialog( "*.HEX", "Open-Hex", "~N~ame", fdOpenButton, 100 ));
    if( d != NULL && deskTop->execView( d ) != cmCancel )
	d->getFileName( fileName );
    destroy( d );
    if (strcmp(fileName,"")!=0) {
       fr = fopen(fileName,"r");
       if (fr==NULL) {
	  Beep();
	  messageBox("Bad HEX file.",mfError+mfOKButton);
	  goto EndTrf;
       }
       CodeWnd->ClearDat();
       EpromWnd->ClearDat();
       IdentWnd->ClearDat();
       strcpy(StrBuf,"");
       while (fscanf(fr,"%s\n",&StrBuf)!=EOF) {
	  Length = CRC = Data = 0;
	  if (StrBuf[0]!=':') {
	     Beep();
	     messageBox("File not Intel HEX format.",mfError+mfOKButton);
	     goto EndTrf;
	  }
	  memcpy(Buf,&StrBuf[1],2);
	  sscanf(Buf,"%X",&Length);
	  for (i=0;i<Length+5;i++) {
	      memcpy(Buf,&StrBuf[2*i+1],2);
	      sscanf(Buf,"%X",&Data);
	      CRC += Data; CRC &= 0xFF;
	  }
	  if (CRC!=0) {
	     Beep();
	     messageBox("CRC error in file.",mfError+mfOKButton);
	     goto EndTrf;
	  }
	  memcpy(Buf,&StrBuf[7],2);
	  sscanf(Buf,"%X",&Direct);
	  if (Direct==0) {
	     memcpy(AdrBuf,&StrBuf[3],4);
	     sscanf(AdrBuf,"%X",&OffAdr);
	     OffAdr /= 2;
	     for (i=0;i<Length/2;i++) {
		 memcpy(DataBuf,&StrBuf[4*i+11],2);
		 memcpy(&DataBuf[2],&StrBuf[4*i+9],2);
		 sscanf(DataBuf,"%X",&Data);
		 if ((OffAdr+i)<=0x3FF) {
		    if (Data>0x3FFF) {
		       Beep();
		       messageBox("Data not defined for PIC16F84.",mfError+mfOKButton);
		       goto EndTrf;
		    }
		    CodeWnd->WriteDat(OffAdr+i,Data);
		 }
		    else
		 if ((OffAdr+i>=0x2100)&&((OffAdr+i)<=0x213F)) {
		    if (Data>0xFF) {
		       Beep();
		       messageBox("Data not defined for PIC16F84.",mfError+mfOKButton);
		       goto EndTrf;
		    }
		    EpromWnd->WriteDat((OffAdr-0x2100)+i,Data);
		 }
		    else
		 if ((OffAdr+i>=0x2000)&&((OffAdr+i)<=0x2003)) {
		    if (Data>0x3FFF) {
		       Beep();
		       messageBox("Data not defined for PIC16F84.",mfError+mfOKButton);
		       goto EndTrf;
		    }
		    IdentWnd->WriteDat((OffAdr-0x2000)+i,Data);
		 }
		    else
		 if (OffAdr+i==0x2007) {
		    if (Data>0x3FFF) {
		       Beep();
		       messageBox("Data not defined for PIC16F84.",mfError+mfOKButton);
		       goto EndTrf;
		    }
		    SetWnd->WriteDat(Data);
		 }
	     }
	  }
	  if (Direct==1) {
	     SetWnd->WriteName( fileName, 0 );
	     CodeWnd->redraw();
	     EpromWnd->redraw();
	     IdentWnd->redraw();
	     SetWnd->redraw();
	     fclose( fr );
	     return;
	  }
       }
EndTrf:fclose( fr );
       CodeWnd->ClearDat();
       EpromWnd->ClearDat();
       IdentWnd->ClearDat();
       SetWnd->WriteName( NULL, 0 );
    }
}

void TPicProg::Beep() {                          // procedura pipne
    sound(2000);
    delay(100);
    nosound();
}

void TPicProg::FindPrgm() {                      // procedura nalezne programator
  char StrBuf[20] = "";
    ComX = COM1;                                 // COM1
    if (!TestCom)
       goto Cm2;
    InitCom;
    SetMclr;
    delay(50);
    SetData;
    delay(1);
    if (RdData)
       goto DetPort;                             // ok
Cm2:ComX = COM2;                                 // COM2
    if (!TestCom)
       goto Cm3;
    InitCom;
    SetMclr;
    delay(50);
    SetData;
    delay(1);
    if (RdData)
       goto DetPort;                             // ok
Cm3:ComX = COM3;                                 // COM3
    if (!TestCom)
       goto Cm4;
    InitCom;
    SetMclr;
    delay(50);
    SetData;
    delay(1);
    if (RdData)
       goto DetPort;                             // ok
Cm4:ComX = COM4;                                 // COM4
    if (!TestCom)
       goto CmX;
    InitCom;
    SetMclr;
    delay(50);
    SetData;
    delay(1);
    if (RdData)
       goto DetPort;                             // ok
CmX:ComX = NULL;
    Beep();
    messageBox("Programmer not found.",mfError+mfOKButton);
DetPort:
    switch ( ComX ) {                            // aktivni port
      case COM1 :
	strcpy(StrBuf,"PORT: COM1");
      break;
      case COM2 :
	strcpy(StrBuf,"PORT: COM2");
      break;
      case COM3 :
	strcpy(StrBuf,"PORT: COM3");
      break;
      case COM4 :
	strcpy(StrBuf,"PORT: COM4");
      break;
      default :
	strcpy(StrBuf,"PORT: none");
      break;
    }
    ClrData;
    destroy( SetWnd->PortInfo );
    SetWnd->PortInfo = new TStaticText(TRect(3,8,31,9),StrBuf);
    SetWnd->insert( SetWnd->PortInfo );
    redraw();
}

void TPicProg::ReadPIC() {                       // procedura nacte PIC
  int i;
    status = dread;
    ResChip;                                     // reset procesoru
    for (i=0;i<1024;i++) {
	CMD(0x04);                               // odeslani povelu
	CodeWnd->WriteDat(i,RdDATA());           // nacteni dat
	CMD(0x06);                               // posun adresy
    }
    for (i=0;i<64;i++) {
	CMD(0x05);                               // odeslani povelu
	EpromWnd->WriteDat(i,RdDATA()&0xFF);     // nacteni dat
	CMD(0x06);                               // posun adresy
    }
    CMD(0);                                      // nastaveni adresy 2000
    WrDATA(0x3FFF);                              // ok
    for (i=0;i<4;i++) {                          // nacteni adresy 2000-2007
	CMD(4);
	IdentWnd->WriteDat(i,RdDATA());          // ok
	CMD(0x06);                               // posun adresy
    }                                            // ok
    for (i=0;i<3;i++)                            // prenos identifikace
	CMD(0x06);
    CMD(0x04);
    SetWnd->WriteDat(RdDATA());                  // prenos konfigurace
    SetWnd->WriteName("OPEN FILE: from device.", 1);
    CodeWnd->redraw();
    EpromWnd->redraw();
    IdentWnd->redraw();
    SetWnd->redraw();
}

void TPicProg::WritePIC() {                      // procedura naprogramuje PIC
  int i,j, MemDat;
    status = dwrite;
    ResChip;                                     // reset procesoru
    for (i=0;i<1024;i++) {                       // test prazdne pameti
	CMD(0x04);
	if (RdDATA()!=0x3FFF) {
	   Beep();
	   if (messageBox("CODE memory not blank.Rebuild?",mfWarning+mfYesButton+mfNoButton)==cmNo)
	      return;
	      else
		   goto EraseProg;
	}
	CMD(0x08);
    }
    for (i=0;i<64;i++) {                         // test prazdne pameti
	CMD(0x05);
	if ((RdDATA()&0xFF)!=0xFF) {
	   Beep();
	   if (messageBox("EEPROM memory not blank.Rebuild?",mfWarning+mfYesButton+mfNoButton)==cmNo)
	      return;
	      else
		   goto EraseProg;
	}
	CMD(0x08);
    }
    goto RunProg;
EraseProg:
    ResChip;                                     // nastaveni protect modu
    CMD(0);                                      // jinak se nasmaze EEPROM
    WrDATA(0x3FFF);                              // ok
    for (i=0;i<7;i++)
	CMD(0x06);
    CMD(0x02);
    WrDATA(0x00);
    CMD(0x08);
    delay(10);                                   // ok
    ResChip;                                     // reset procesoru
    CMD(0);                                      // nastaveni adresy 2000
    WrDATA(0x3FFF);                              // ok
    for (i=0;i<7;i++)
	CMD(0x06);                               // posun adresy
    CMD(0x01);                                   // vymazani picu
    CMD(0x07);
    CMD(0x08);
    delay(10);
    CMD(0x01);
    CMD(0x07);                                   // ok
RunProg:
    ResChip;                                     // reset procesoru
    for (i=0;i<1024;i++) {                       // zapis kodu
	MemDat = CodeWnd->ReadDat(i);
	CMD(0x04);
	if (MemDat==RdDATA())
	   goto NoPrgCode;
	CMD(0x02);
	WrDATA(MemDat);
	CMD(0x08);
	delay(10);
	CMD(0x04);
	if (RdDATA()!=MemDat) {
	   Beep();
	   messageBox("CODE programming failure.",mfError+mfOKButton);
	   return;
	}
NoPrgCode:CMD(0x06);
    }
    for (i=0;i<64;i++) {                         // zapis dat do eeprom
	MemDat = EpromWnd->ReadDat(i);
	CMD(0x05);
	if (MemDat==RdDATA())
	   goto NoPrgData;
	CMD(0x03);
	WrDATA(MemDat);
	CMD(0x08);
	delay(10);
	CMD(0x05);
	if ((RdDATA()&0xFF)!=MemDat) {
	   Beep();
	   messageBox("EEPROM programming failure.",mfError+mfOKButton);
	   return;
	}
NoPrgData:CMD(0x06);
    }
    CMD(0x00);
    WrDATA(0x3FFF);
    for (i=0;i<4;i++) {                          // zapis dat identifikace
	MemDat = IdentWnd->ReadDat(i);
	CMD(0x04);
	if (MemDat==RdDATA())
	   goto NoPrgIdent;
	CMD(0x02);
	WrDATA(MemDat);
	CMD(0x08);
	delay(10);
	CMD(0x04);
	if (RdDATA()!=MemDat) {
	   Beep();
	   messageBox("Identification programming failure.",mfError+mfOKButton);
	   return;
	}
NoPrgIdent:CMD(0x06);
    }
    for (i=0;i<3;i++)                            // posun adresy
	CMD(0x06);
    MemDat = SetWnd->ReadDat();
    CMD(0x04);
    if (MemDat==RdDATA())
       goto VerPIC;
    CMD(0x02);
    WrDATA(MemDat);
    CMD(0x08);
    delay(10);
    CMD(0x04);
    if (RdDATA()!=MemDat) {
       Beep();
       messageBox("Configuration programming failure.",mfError+mfOKButton);
       return;
    }
VerPIC:VerifyPIC();                                 // kontrola nprogramovani
}

void TPicProg::VerifyPIC() {                     // procedura porovna data
  int i;
  unsigned int MemDat;
    status = dverify;
    ResChip;
    CMD(0);                                      // nastaveni adresy 2000
    WrDATA(0x3FFF);                              // ok
    for (i=0;i<4;i++) {                          // nacteni adresy 2000-2007
	CMD(4);
	if (RdDATA()!=IdentWnd->ReadDat(i)) {
	   Beep();
	   messageBox("Identification verify error.",mfError+mfOKButton);
	   return;
	}
	CMD(0x06);                               // posun adresy
    }                                            // ok
    for (i=0;i<3;i++)                            // posun adresy
	CMD(0x06);
    CMD(0x04);
    MemDat = RdDATA();
    if (MemDat!=SetWnd->ReadDat()) {
       Beep();
       messageBox("Configuration verify error.",mfError+mfOKButton);
       return;
    }
    if ((MemDat&0x3FF0)!=0x3FF0)
       return;
    ResChip;
    for (i=0;i<1024;i++) {
	CMD(0x04);
	if (RdDATA()!=CodeWnd->ReadDat(i)) {
	   Beep();
	   messageBox("CODE verify error.",mfError+mfOKButton);
	   return;
	}
	CMD(0x06);
    }
    for (i=0;i<64;i++) {
	CMD(0x05);
	if ((RdDATA()&0xFF)!=EpromWnd->ReadDat(i)) {
	   Beep();
	   messageBox("EEPROM verify error.",mfError+mfOKButton);
	   return;
	}
	CMD(0x06);
    }
}

void TPicProg::ErasePIC() {                      // procedura nacte PIC
  int i;
    status = derase;
    ResChip;                                     // nastaveni protect modu
    CMD(0);                                      // jinak se nasmaze EEPROM
    WrDATA(0x3FFF);                              // ok
    for (i=0;i<7;i++)
	CMD(0x06);
    CMD(0x02);
    WrDATA(0x00);
    CMD(0x08);
    delay(10);                                   // ok
    ResChip;                                     // reset procesoru
    CMD(0);                                      // nastaveni adresy 2000
    WrDATA(0x3FFF);                              // ok
    for (i=0;i<7;i++)
	CMD(0x06);                               // posun adresy
    CMD(0x01);                                   // vymazani picu
    CMD(0x07);
    CMD(0x08);
    delay(10);
    CMD(0x01);
    CMD(0x07);                                   // ok
    CodeWnd->ClearDat();                         // vymazani oken
    EpromWnd->ClearDat();
    IdentWnd->ClearDat();
    SetWnd->ClearDat();                          // ok
}

void TPicProg::CurOvl(Boolean Stav) {            // ovladani kurzoru
    CodeWnd->CurOvl( Stav );
    EpromWnd->CurOvl( Stav );
    IdentWnd->CurOvl( Stav );
    SetWnd->CurOvl( Stav );
}

TPalette& TPicProg::getPalette() const {         // definice barev
    char MyColor[100] = cpColor;
    memcpy(MyColor,"\x71\x07\x0A\x0E\x70\x7A\x7E",7);
    memcpy(&MyColor[63],"\x02\x09\x06\x0F",4);
    MyColor[27] = '\x0E';
    static TPalette palette( MyColor, sizeof( MyColor ) - 1);
    return palette;
}

/* ============================= TCodeWnd ==================================*/

TCodeWnd::TCodeWnd() :                           // konstruktor okna kodu
    TWindow(TRect(0,0,48,23),"CODE",NULL),
    TWindowInit( &TCodeWnd::initFrame)
{
  int i;
  char StrBuf[10];
    flags = 0;                                   // staticke okno
    setState(sfShadow,False);                    // ramecek bez stinu
    AdrWnd = new TStaticText(TRect(2,22,13,23)," ADR:0000H ");
    insert( AdrWnd );
    MyBar = new TScrollBar(TRect(47,1,48,22));
    insert( MyBar );
    CODE = new TEditor(TRect(2,1,47,22),NULL,MyBar,NULL,10000);
    insert ( CODE );                             // pole objektu editoru
    for (i=0;i<1024;i++) {
	if ((i%8)==0) {                          // prenos adresy
	   sprintf(StrBuf,"%04X\xB3",i);
	   CODE->insertText(StrBuf,5,False);
	}                                        // ok
	CODE->insertText("3FFF ",5,False);
	if ((((i+1)%8)==0)&&(i!=0x3FF))
	   CODE->newLine();                      // ok
    }
    DataAdr = Pos = 0;                           // nastaveni kurzoru
    MakeCurPos();                                // ok
}

void TCodeWnd::handleEvent(TEvent& event) {      // procedura udalosti okna kodu
  int i, radek, poradi;
  char KeyBuf;
    if ((event.what)==evMouseDown) {             // mysi udalosti
       if (getState(sfActive)==False) {
	  TWindow::handleEvent( event );
	  return;
       }
       i = CODE->getMousePtr(event.mouse.where);
       if (((i%47)>=5)&&((i%47)<=43)) {
	  DataAdr = (i/47)*8+((i%47)-5)/5;
	  Pos = ((i%47)-5)%5;
	  if (Pos>3)
	     Pos = 3;
	  MakeCurPos();
       }
       if ((i%47)>43) {
	  MyBar->handleEvent( event );
	  CODE->scrollTo(0,MyBar->value);
       }
    }
    if ((event.what)==evKeyboard) {              // klavesove udalosti
	KeyBuf = toupper( event.keyDown.keyCode&0xFF );
	if (CODE->getState(sfCursorIns)) {
	   switch ( KeyBuf ) {                   // selekce platnych znaku
	     case 'F' :
	     case 'E' :
	     case 'D' :
	     case 'C' :
	     case 'B' :
	     case 'A' :
	     case '9' :
	     case '8' :
	     case '7' :
	     case '6' :
	     case '5' :
	     case '4' :
	       if (Pos==0)                       // platna cisla 0,1,2,3
		  break;
	     case '3' :
	     case '2' :
	     case '1' :
	     case '0' :
	       event.keyDown.keyCode = KeyBuf;
	       TWindow::handleEvent( event );    // ulozeni znaku
	       event.keyDown.keyCode = kbRight;  // posun doprava
	     break;
	     default :
	     break;
	   }
	}
       switch ( event.keyDown.keyCode ) {       // obsluha funkcnich klaves
	 case kbIns :                           // klavesa editace
	   CODE->toggleInsMode();
	 break;
	 case kbHome :                           // skok na zacatek
	   DataAdr = Pos = 0;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbEnd :                            // skok na konec
	   DataAdr = 0x3FF;
	   Pos = 3;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbPgDn :                           // posun o stranku dolu
	   i = DataAdr + 168;
	   if (i<=0x3FF)
	      DataAdr = i;
	      else
		   {
		     DataAdr = 0x3FF;
		     Pos = 3;
		   }
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;                                  // ok
	 case kbPgUp :                           // posun o stranku nahoru
	   i = DataAdr - 168;
	   if (i>=0)
	      DataAdr = i;
	      else
		   DataAdr = Pos = 0;            // ok
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbRight :                          // posun o znak doprava
	   i = Pos + 1;
	   if (i>3) {
	      DataAdr++;
	      Pos = 0;
	   }
	    else
		 Pos = i;                        // ok
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbLeft :                           // posun o znak doleva
	   i = Pos - 1;
	   if (i<0) {
	      DataAdr--;
	      Pos = 3;
	   }
	     else
		   Pos = i;                      // ok
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbDown :                           // posun o radek dolu
	   i = DataAdr + 8;
	   if (i<=0x3FF)
	      DataAdr = i;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;                                  // ok
	 case kbUp :                             // posun o radek nahoru
	   i = DataAdr - 8;
	   if (i>=0)
	      DataAdr = i;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;                                  // ok
	 default :
	 break;
       }
    }                                            // udalosti predchudce
}

void TCodeWnd::ClearDat() {                      // procedura smaze okna kodu
  int i;
     CODE->setCurPtr(6013,normalSelect);
     for (i=0;i<1024;i++)
	 memcpy(CODE->buffer+5+47*(i/8)+5*(i%8),"3FFF",4);
     Pos = DataAdr = 0;
     MakeCurPos();
     if (CODE->getState(sfCursorIns)==True)
	CODE->toggleInsMode();
     redraw();
}

void TCodeWnd::MakeCurPos() {                    // vypocet pozice kurzoru
   char StrBuf[20];
    if (DataAdr<0)                               // osetreni mezi adres
       Pos = DataAdr = 0;
    if (DataAdr>0x3FF) {
       DataAdr = 0x3FF;
       Pos = 3;
    }                                            // ok
    CODE->setCurPtr(5+47*(DataAdr/8)+5*(DataAdr%8)+Pos,normalSelect);
    if (CODE->cursorVisible()==False)
       CODE->scrollTo(0,CODE->curPos.y);
    destroy( AdrWnd );
    sprintf( StrBuf," ADR:%04XH ",DataAdr);
    AdrWnd = new TStaticText(TRect(2,22,13,23),StrBuf);
    insert( AdrWnd );
}                                                // ok

void TCodeWnd::WriteDat(int Adr, int Data) {     // zapis dat do pole kodu
  char StrBuf[5];
     sprintf(StrBuf,"%04X",Data);
     CODE->setCurPtr(6013,normalSelect);
     memcpy(CODE->buffer+5+47*(Adr/8)+5*(Adr%8),StrBuf,4);
     CODE->setCurPtr(5+47*(DataAdr/8)+5*(DataAdr%8)+Pos,normalSelect);
     if (CODE->cursorVisible()==False)
	CODE->scrollTo(0,CODE->curPos.y);
}

unsigned int TCodeWnd::ReadDat(int Adr) {        // cteni dat z pole
  char StrBuf[5];
  unsigned int i;
     CODE->setCurPtr(6013,normalSelect);
     memcpy(StrBuf,CODE->buffer+5+47*(Adr/8)+5*(Adr%8),4);
     StrBuf[4] = '\0';
     sscanf(StrBuf,"%X",&i);
     CODE->setCurPtr(5+47*(DataAdr/8)+5*(DataAdr%8)+Pos,normalSelect);
     if (CODE->cursorVisible()==False)
	CODE->scrollTo(0,CODE->curPos.y);
     return(i);
}

void TCodeWnd::CurOvl(Boolean Stav) {            // ovladani kurzoru
    if (Stav==False)
       CODE->hideCursor();
       else
	    CODE->showCursor();
}

TPalette& TCodeWnd::getPalette() const {         // definice barev
char cpMyWnd[] = { 64,64,64,64,64,64,64,64 };
    static TPalette palette( cpMyWnd, sizeof( cpMyWnd ) - 1);
    return palette;
}

/* ============================ TEpromWnd ==================================*/

TEpromWnd::TEpromWnd() :                         // konstruktor okna kodu
    TWindow(TRect(48,0,80,10),"EEPROM",NULL),
    TWindowInit( &TEpromWnd::initFrame)
{
  int i;
  char StrBuf[10];
    flags = 0;                                   // staticke okno
    setState(sfShadow,False);                    // ramecek bez stinu
    AdrWnd = new TStaticText(TRect(2,9,13,10)," ADR:2100H ");
    insert( AdrWnd );
    EPROM = new TEditor(TRect(2,1,31,9),NULL,NULL,NULL,1000);
    insert ( EPROM );                            // pole objektu editoru
    for (i=0;i<64;i++) {
	if ((i%8)==0) {                          // prenos adresy
	   sprintf(StrBuf,"21%02X\xB3",i);
	   EPROM->insertText(StrBuf,5,False);
	}                                        // ok
	EPROM->insertText("FF ",3,False);
	if ((((i+1)%8)==0)&&(i!=0x3F))
	   EPROM->newLine();                      // ok
    }
    DataAdr = Pos = 0;                           // nastaveni kurzoru
    MakeCurPos();                                // ok
}

void TEpromWnd::handleEvent(TEvent& event) {     // procedura udalosti okna kodu
  int i;
  char KeyBuf;
    if ((event.what)==evMouseDown) {             // mysi udalosti
       if (getState(sfActive)==False) {
	  TWindow::handleEvent( event );
	  return;
       }
       i = EPROM->getMousePtr(event.mouse.where);
       if (((i%31)>=5)&&((i%31)<=27)) {
	  DataAdr = (i/31)*8+((i%31)-5)/3;
	  Pos = ((i%31)-5)%3;
	  if (Pos>1)
	     Pos = 1;
	  MakeCurPos();
       }
    }
    if ((event.what)==evKeyboard) {              // klavesove udalosti
	KeyBuf = toupper( event.keyDown.keyCode&0xFF );
	if (EPROM->getState(sfCursorIns)) {
	   switch ( KeyBuf ) {                   // selekce platnych znaku
	     case 'F' :
	     case 'E' :
	     case 'D' :
	     case 'C' :
	     case 'B' :
	     case 'A' :
	     case '9' :
	     case '8' :
	     case '7' :
	     case '6' :
	     case '5' :
	     case '4' :
	     case '3' :
	     case '2' :
	     case '1' :
	     case '0' :
	       event.keyDown.keyCode = KeyBuf;
	       TWindow::handleEvent( event );    // ulozeni znaku
	       event.keyDown.keyCode = kbRight;  // posun doprava
	     break;
	     default :
	     break;
	   }
	}
	switch ( event.keyDown.keyCode ) {       // obsluha funkcnich klaves
	 case kbIns :                            // klavesa editace
	   EPROM->toggleInsMode();
	 break;
	 case kbHome :                           // skok na zacatek
	   DataAdr = Pos = 0;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbEnd :                            // skok na konec
	   DataAdr = 0x3F;
	   Pos = 1;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbRight :                          // posun o znak doprava
	   i = Pos + 1;
	   if (i>1) {
	      DataAdr++;
	      Pos = 0;
	   }
	    else
		 Pos = i;                        // ok
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbLeft :                           // posun o znak doleva
	   i = Pos - 1;
	   if (i<0) {
	      DataAdr--;
	      Pos = 1;
	   }
	     else
		   Pos = i;                      // ok
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbDown :                           // posun o radek dolu
	   i = DataAdr + 8;
	   if (i<=0x3F)
	      DataAdr = i;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;                                  // ok
	 case kbUp :                             // posun o radek nahoru
	   i = DataAdr - 8;
	   if (i>=0)
	      DataAdr = i;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;                                  // ok
	 default :
	 break;
       }
    }                                            // udalosti predchudce
}

void TEpromWnd::MakeCurPos() {                   // vypocet pozice kurzoru
   char StrBuf[20];
    if (DataAdr<0)                               // osetreni mezi adres
       Pos = DataAdr = 0;
    if (DataAdr>0x3F) {
       DataAdr = 0x3F;
       Pos = 1;
    }                                            // ok
    EPROM->setCurPtr(5+31*(DataAdr/8)+3*(DataAdr%8)+Pos,normalSelect);
    if (EPROM->cursorVisible()==False)
       EPROM->scrollTo(0,EPROM->curPos.y);
    destroy( AdrWnd );
    sprintf( StrBuf," ADR:21%02XH ",DataAdr);
    AdrWnd = new TStaticText(TRect(2,9,13,10),StrBuf);
    insert( AdrWnd );
}

void TEpromWnd::ClearDat() {                     // vymaz vnitrni pameti dat
  int i;
    EPROM->setCurPtr(245,normalSelect);
    for (i=0;i<64;i++)
	memcpy(EPROM->buffer+5+31*(i/8)+3*(i%8),"FF",2);
    Pos = DataAdr = 0;
    MakeCurPos();
    if (EPROM->getState(sfCursorIns)==True)
       EPROM->toggleInsMode();
    redraw();
}

void TEpromWnd::WriteDat(int Adr, int Data) {     // zapis dat do pole eprom
  char StrBuf[3];
     sprintf(StrBuf,"%02X",Data);
     EPROM->setCurPtr(245,normalSelect);
     memcpy(EPROM->buffer+5+31*(Adr/8)+3*(Adr%8),StrBuf,2);
     EPROM->setCurPtr(5+31*(DataAdr/8)+3*(DataAdr%8)+Pos,normalSelect);
     if (EPROM->cursorVisible()==False)
	EPROM->scrollTo(0,EPROM->curPos.y);
}

unsigned int TEpromWnd::ReadDat(int Adr) {        // cteni dat z pole
  char StrBuf[3];
  unsigned int i;
     EPROM->setCurPtr(245,normalSelect);
     memcpy(StrBuf,EPROM->buffer+5+31*(Adr/8)+3*(Adr%8),2);
     StrBuf[2] = '\0';
     sscanf(StrBuf,"%X",&i);
     EPROM->setCurPtr(5+31*(DataAdr/8)+3*(DataAdr%8)+Pos,normalSelect);
     if (EPROM->cursorVisible()==False)
	EPROM->scrollTo(0,EPROM->curPos.y);
     return(i);
}

void TEpromWnd::CurOvl(Boolean Stav) {            // ovladani kurzoru
    if (Stav==False)
       EPROM->hideCursor();
       else
	    EPROM->showCursor();
}

TPalette& TEpromWnd::getPalette() const {        // definice barev
char cpMyWnd[] = { 65,65,65,65,65,65,65,65 };
    static TPalette palette( cpMyWnd, sizeof( cpMyWnd ) - 1);
    return palette;
}

/* ============================ TIdentWnd ==================================*/

TIdentWnd::TIdentWnd() :                         // konstruktor okna identifikace
    TWindow(TRect(48,10,80,13),"IDENTIFICATION",NULL),
    TWindowInit( &TIdentWnd::initFrame)
{
  int i;
    flags = 0;                                   // staticke okno
    setState(sfShadow,False);                    // ramecek bez stinu
    Ident = new TEditor(TRect(2,1,31,2),NULL,NULL,NULL,100);
    insert ( Ident );                            // pole objektu editoru
    Ident->insertText("2000\xB3 ",6,False);
    for (i=0;i<4;i++)
	Ident->insertText("3FFF  ",6,False);
    DataAdr = Pos = 0;                           // nastaveni kurzoru
    MakeCurPos();                                // ok
}

void TIdentWnd::handleEvent(TEvent& event) {     // procedura udalosti okna kodu
  int i;
  char KeyBuf;
    if ((event.what)==evMouseDown) {             // mysi udalosti
       if (getState(sfActive)==False) {
	  TWindow::handleEvent( event );
	  return;
       }
       i = Ident->getMousePtr(event.mouse.where);
       if ((i>=6)&&(i<=27)) {
	  DataAdr = (i-6)/6;
	  Pos = (i-6)%6;
	  if (Pos>3)
	     Pos = 3;
	  MakeCurPos();
       }
    }
    if ((event.what)==evKeyboard) {              // klavesove udalosti
	KeyBuf = toupper( event.keyDown.keyCode&0xFF );
	if (Ident->getState(sfCursorIns)) {
	   switch ( KeyBuf ) {                   // selekce platnych znaku
	     case 'F' :
	     case 'E' :
	     case 'D' :
	     case 'C' :
	     case 'B' :
	     case 'A' :
	     case '9' :
	     case '8' :
	     case '7' :
	     case '6' :
	     case '5' :
	     case '4' :
	       if (Pos==0)                       // platna cisla 0,1,2,3
		  break;
	     case '3' :
	     case '2' :
	     case '1' :
	     case '0' :
	       event.keyDown.keyCode = KeyBuf;
	       TWindow::handleEvent( event );    // ulozeni znaku
	       event.keyDown.keyCode = kbRight;  // posun doprava
	     break;
	     default :
	     break;
	   }
	}
	switch ( event.keyDown.keyCode ) {       // obsluha funkcnich klaves
	 case kbIns :                            // klavesa editace
	   Ident->toggleInsMode();
	 break;
	 case kbHome :                           // skok na zacatek
	   DataAdr = Pos = 0;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbEnd :                            // skok na konec
	   DataAdr = Pos = 3;
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbRight :                          // posun o znak doprava
	   i = Pos + 1;
	   if (i>3) {
	      DataAdr++;
	      Pos = 0;
	   }
	    else
		 Pos = i;                        // ok
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 case kbLeft :                           // posun o znak doleva
	   i = Pos - 1;
	   if (i<0) {
	      DataAdr--;
	      Pos = 3;
	   }
	     else
		   Pos = i;                      // ok
	   MakeCurPos();                         // obsluha pozice kurzoru
	 break;
	 default :
	 break;
       }
    }                                            // udalosti predchudce
}

void TIdentWnd::ClearDat() {                     // vymaz vnitrni pameti dat
  int i;
    Ident->setCurPtr(45,normalSelect);
    for (i=0;i<4;i++)
	memcpy(Ident->buffer+6+6*i,"3FFF",4);
    Pos = DataAdr = 0;
    MakeCurPos();
    if (Ident->getState(sfCursorIns)==True)
       Ident->toggleInsMode();
    redraw();
}

void TIdentWnd::MakeCurPos() {                   // vypocet pozice kurzoru
    if (DataAdr<0)                               // osetreni mezi adres
       Pos = DataAdr = 0;
    if (DataAdr>3) {
       DataAdr = Pos = 3;
    }                                            // ok
    Ident->setCurPtr(6+6*DataAdr+Pos,normalSelect);
}

void TIdentWnd::WriteDat(int Adr, int Data) {     // zapis dat do pole kodu
  char StrBuf[5];
     sprintf(StrBuf,"%04X",Data);
     Ident->setCurPtr(45,normalSelect);
     memcpy(Ident->buffer+6+6*Adr,StrBuf,4);
     MakeCurPos();
}

unsigned int TIdentWnd::ReadDat(int Adr) {        // cteni dat z pole
  char StrBuf[5];
  unsigned int i;
     memcpy(StrBuf,Ident->buffer+6+6*Adr,4);
     StrBuf[4] = '\0';
     sscanf(StrBuf,"%X",&i);
     return(i);
}

void TIdentWnd::CurOvl(Boolean Stav) {           // ovladani kurzoru
    if (Stav==False)
       Ident->hideCursor();
       else
	    Ident->showCursor();
}

TPalette& TIdentWnd::getPalette() const {        // definice barev
char cpMyWnd[] = { 66,66,66,66,66,66,66,66 };
    static TPalette palette( cpMyWnd, sizeof( cpMyWnd ) - 1);
    return palette;
}

/* ============================ TControlWnd ===============================*/

TControlWnd::TControlWnd() :                     // konstruktor okna rizeni
    TDialog(TRect(48,13,80,23),"CONTROL"),
    TWindowInit( &TControlWnd::initFrame)
{
    flags = 0;                                   // staticke okno
    setState(sfShadow,False);                    // ramecek bez stinu
    ModeProg = new TCheckBoxes(TRect(15,2,28,5),
	       new TSItem("WDT",
	       new TSItem("PUT",
	       new TSItem("Protect",NULL))));
    insert( ModeProg );
    Speed = new TRadioButtons(TRect(4,2,12,6),
	       new TSItem("LP",
	       new TSItem("XT",
	       new TSItem("HS",
	       new TSItem("RC",NULL)))));
    insert( Speed );
    insert( new TStaticText(TRect(16,1,27,2),"Prog. mode:") );
    insert( new TStaticText(TRect(3,1,13,2),"Oscilator:") );
    FileInfo = new TStaticText(TRect(3,7,31,8),"OPEN FILE: No file load!");
    PortInfo = new TStaticText(TRect(3,8,31,9),"PORT: none");
    insert( FileInfo );
    insert( PortInfo );
    ClearDat();
}

void TControlWnd::handleEvent(TEvent& event) {   // procedura udalosti okna kodu
    if ((event.what)==evMouseDown)               // mysi udalosti
       TWindow::handleEvent( event );
    if ((event.what)==evKeyboard) {              // klavesove udalosti
	switch ( event.keyDown.keyCode ) {       // obsluha funkcnich klaves
	 case kbUp:
	 case kbDown:
	 case 0x3920:
	   TDialog::handleEvent( event );
	 break;
	 case kbRight:
	   ModeProg->select();
	 break;
	 case kbLeft:
	   Speed->select();
	 break;
	 default :
	 break;
       }
    }                                            // udalosti predchudce
}

void TControlWnd::ClearDat() {                   // reset prvku programovani
    WriteDat(0x3FFF);
    destroy( FileInfo );
    FileInfo = new TStaticText(TRect(3,7,31,8),"OPEN FILE: No file load!");
    insert( FileInfo );
    redraw();
}

void TControlWnd::WriteDat(int Data) {          // zapis dat do pole kodu
     int Buf = Data&0x0003;
     Speed->setData( &Buf );
     Buf = 0;
     if ( (Data&0x0004)!=0 )
	Buf |= 0x0001;
     if ( (Data&0x0008)==0 )
	Buf |= 0x0002;
     if ( (Data&0x3FF0)!=0x3FF0 )
	Buf |= 0x0004;
     ModeProg->setData( &Buf );
}

unsigned int TControlWnd::ReadDat() {            // cteni dat konfigurace
  unsigned int i = 0, Buf;
     Speed->getData( &Buf );
     i = Buf&0x03;
     ModeProg->getData( &Buf );
     if ( (Buf&0x0001)!=0 )
	i |= 0x0004;
     if ( (Buf&0x0002)==0 )
	i |= 0x0008;
     if ( (Buf&0x0004)==0 )
	i |= 0x3FF0;
     return( i );
}

void TControlWnd::WriteName( char *StrBuf, int Par ) {
  char Buf[40], NameBuf[9], ExtBuf[5];
    if ( StrBuf==NULL ) {
       strcpy(Buf,"OPEN FILE: No file load.");
    }
      else
	   if (Par==0) {
	     _splitpath(StrBuf,NULL,NULL,NameBuf,ExtBuf);
	     strcpy(Buf,"OPEN FILE: ");
	     strcat(Buf,NameBuf);
	     strcat(Buf,ExtBuf);
	   }
	    else
		 strcpy(Buf,StrBuf);
    destroy( FileInfo );
    FileInfo = new TStaticText(TRect(3,7,31,8),Buf);
    insert( FileInfo );
}

void TControlWnd::CurOvl(Boolean Stav) {         // ovladani kurzoru
    if (Stav==False) {
       Speed->hideCursor();
       ModeProg->hideCursor();
    }
      else
	   {
	     Speed->showCursor();
	     ModeProg->showCursor();
	   }
}

TPalette& TControlWnd::getPalette() const {     // definice barev
  char cpMyWnd[] =
  "\x43\x43\x43\x23\x24\x43\x26\x27\x28\x29\x2A\x2B\x2C\x2D\x2E\x2F\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x3A\x3B\x3C\x3D\x3E\x3F";
    static TPalette palette( cpMyWnd, sizeof( cpMyWnd ) - 1);
    return palette;
}

/* ======================== prerusovaci procedury ========================= */

void interrupt (far *OldTimer)(...) = NULL;      // stara osluha preruseni

void interrupt far NewTimer(...) {               // nova obsluha preruseni
  int X,Y;
  const char PosRotator[] = {'|','/','-','\\'};
  char StrBuf[10];
    if (Delitel++>3) {
       Delitel = 0;
       if (status!=none) {
	  if (Rotator++>=3)
	     Rotator = 0;
	  switch (status) {
	    case dread :
	      strcpy(StrBuf,"read");
	    break;
	    case dwrite :
	      strcpy(StrBuf,"write");
	    break;
	    case dverify :
	      strcpy(StrBuf,"verify");
	    break;
	    case derase :
	      strcpy(StrBuf,"erase");
	    break;
	    default :
	    break;
	  }
	  X = wherex(); Y = wherey();
	  gotoxy(73-strlen(StrBuf),1);
	  printf("%s PIC...%c",StrBuf,PosRotator[Rotator]);
	  gotoxy( X,Y );
       }
    }
    (*OldTimer)();                               // stare preruseni
}

/* ============================ hlavni program ============================ */

int main() {
    TPicProg MyApp;                        // spusteni konstruktoru
    AppPtr = &MyApp;                       // zjisteni ukazatele
    OldTimer = getvect(0x1C);              // stary casovac
    setvect(0x1C,NewTimer);                // novy casovac
    MyApp.run();                           // proces udalosti
    setvect(0x1C,OldTimer);                // obnova stareho preruseni
    return 0;                              // konec programu
}